// Omnibus or gondola
// Ticket for gondola = 2x ticket for omnibus

#include <bits/stdc++.h>
using namespace std;

int V, E, Vp;
vector<vector<int>> adj;

int tour_fee(int start, int finish)
{
  vector<bool> visited(V+2);
  vector<int> fee(V+2);
  queue<int> Q;
  visited[start] = true;
  Q.push(start);
  while(!Q.empty())
  {
    int v = Q.front(); Q.pop();
    // cout << v << '\n';
    for(int x : adj[v])
    {
      if(visited[x]) continue;
      fee[x] = 1 + fee[v];
      if(x == finish) return fee[x];
      visited[x] = true;
      Q.push(x);
    }
  }
  return -1;
}

int main()
{
  cin >> V >> E;
  adj.resize(V+2); // + Atlantis
  for(int i=0; i<E; i++)
  {
    int a, b; cin >> a >> b;
    adj[a].push_back(b);
    adj[b].push_back(a);
  }
  // ports
  cin >> Vp;
  for(int i=0; i<Vp; i++)
  {
    int p; cin >> p;
    adj[V+1].push_back(p); // connected to Atlantis
    adj[p].push_back(V+1);
  }
  // debug
  /*
  for(int i=1; i<=V+1; i++)
  {
    cout << i << ":";
    for(int v : adj[i])
      cout << " " << v;
    cout << '\n';
  }*/
  int Z; cin >> Z;
  while(Z--)
  {
    int a, b; cin >> a >> b;
    int tf = tour_fee(a, b);
    if(tf >= 0)
      cout << tf << '\n';
    else
      cout << "NIE\n";
  }
  return 0;
}
